
#ifndef _VENUS_ADV_
#define _VENUS_ADV_

/* DO NOT EDIT: generated by rp2gen from /home/aginies/rpm/BUILD/coda-6.0.15/coda-src/vicedep/venus_adv.rpc2 */
#ifdef __cplusplus
extern "C" {
#endif
#include <rpc2/rpc2.h>
#include <rpc2/se.h>
#include <rpc2/errors.h>
#ifdef __cplusplus
}
#endif

 /* BLURB lgpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2003 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the  terms of the  GNU  Library General Public Licence  Version 2,  as
shown in the file LICENSE. The technical and financial contributors to
Coda are listed in the file CREDITS.

                        Additional copyrights
                           none currently

#*/

#define VA_SUBSYSID	300
#ifndef _vcrcommon_rpc2_
#define _vcrcommon_rpc2_
#include "vcrcommon.h"
#endif /* _vcrcommon_rpc2_ */

typedef enum{ TokensAcquiredID=0, TokensExpiredID=1, ActivityPendingTokensID=2, SpaceInformationID=3, ServerAccessibleID=4, ServerInaccessibleID=5, ServerConnectionStrongID=6, ServerConnectionWeakID=7, NetworkQualityEstimateID=8, VolumeTransitionEventID=9, ReconnectionID=10, DataFetchEventID=11, ReadDisconnectedCacheMissEventID=12, WeaklyConnectedCacheMissEventID=13, DisconnectedCacheMissEventID=14, HoardWalkAdviceRequestID=15, HoardWalkBeginID=16, HoardWalkStatusID=17, HoardWalkEndID=18, HoardWalkPeriodicOnID=19, HoardWalkPeriodicOffID=20, ObjectInConflictID=21, ObjectConsistentID=22, ReintegrationPendingTokensID=23, ReintegrationEnabledID=24, ReintegrationActiveID=25, ReintegrationCompletedID=26, TaskAvailabilityID=27, TaskUnavailableID=28, ProgramAccessLogsID=29, ReplacementLogsID=30, InvokeASRID=31 } InterestID;
#define MAXEVENTS	32

typedef struct InterestValuePair {
    InterestID interest;
    RPC2_Integer argument;
    RPC2_Integer value;
} InterestValuePair;

typedef enum{ AgeLimit=0, ReintLimit=1, ReintBarrier=2, WeakThreshold=3 } ParameterID;

typedef struct ParameterValuePair {
    ParameterID parameter;
    RPC2_Integer argument;
    RPC2_Integer value;
} ParameterValuePair;

typedef enum{ AddCMD=0, ClearCMD=1, DeleteCMD=2, ListCMD=3, OffCMD=4, OnCMD=5, WalkCMD=6, VerifyCMD=7 } HoardCommandID;

typedef enum{ NoneMETA=0, ChildrenMETA=1, ChildrenPlusMETA=2, DescendantsMETA=3, DescendantsPlusMETA=4 } MetaInfoID;

typedef struct HoardCmd {
    HoardCommandID command;
    RPC2_String pathname;
    RPC2_Integer priority;
    MetaInfoID meta;
} HoardCmd;

typedef struct ServerEnt {
    RPC2_String name;
    RPC2_Integer bw;
} ServerEnt;

#define VenusAdv_HEAD_VERSION	1155028827

#ifndef _STUB_PREDEFINED_
#define _STUB_PREDEFINED_

typedef struct CallCountEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
} CallCountEntry;

typedef struct MultiCallEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
    RPC2_Integer counthost;
} MultiCallEntry;

typedef struct MultiStubWork {
    RPC2_Integer opengate;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
} MultiStubWork;
#endif /* _STUB_PREDEFINED_ */

/* Op codes and definitions */

#ifdef __cplusplus
extern "C"{
#endif
long VenusAdv_ExecuteRequest(RPC2_Handle cid, RPC2_PacketBuffer *pb, SE_Descriptor *se);

long C_NewAdviceService(RPC2_Handle cid, RPC2_String HostName, RPC2_Integer UserID, RPC2_Integer Port, RPC2_Integer PGrpID, RPC2_Integer *VenusMajorVersionNum, RPC2_Integer *VenusMinorVersionNum);
long S_NewAdviceService(RPC2_Handle cid, RPC2_String HostName, RPC2_Integer UserID, RPC2_Integer Port, RPC2_Integer PGrpID, RPC2_Integer *VenusMajorVersionNum, RPC2_Integer *VenusMinorVersionNum);
#define NewAdviceService_OP	1
extern ARG NewAdviceService_ARGS[];
#define NewAdviceService_PTR	NewAdviceService_ARGS

long C_ConnectionAlive(RPC2_Handle cid, RPC2_Integer UserID);
long S_ConnectionAlive(RPC2_Handle cid, RPC2_Integer UserID);
#define ConnectionAlive_OP	2
extern ARG ConnectionAlive_ARGS[];
#define ConnectionAlive_PTR	ConnectionAlive_ARGS

long C_RegisterInterest(RPC2_Handle cid, RPC2_Integer UserID, RPC2_Integer interests_size_, InterestValuePair interests[]);
long S_RegisterInterest(RPC2_Handle cid, RPC2_Integer UserID, RPC2_Integer interests_size_, InterestValuePair interests[]);
#define RegisterInterest_OP	3
extern ARG RegisterInterest_ARGS[];
#define RegisterInterest_PTR	RegisterInterest_ARGS

long C_GetServerInformation(RPC2_Handle cid, RPC2_Integer servers_size_max_, RPC2_Integer *servers_size_, ServerEnt servers[]);
long S_GetServerInformation(RPC2_Handle cid, RPC2_Integer servers_size_max_, RPC2_Integer *servers_size_, ServerEnt servers[]);
#define GetServerInformation_OP	4
extern ARG GetServerInformation_ARGS[];
#define GetServerInformation_PTR	GetServerInformation_ARGS

long C_GetCacheStatistics(RPC2_Handle cid, RPC2_Integer *FilesAllocated, RPC2_Integer *FilesOccupied, RPC2_Integer *BlocksAllocated, RPC2_Integer *BlocksOccupied, RPC2_Integer *RVMAllocated, RPC2_Integer *RVMOccupied);
long S_GetCacheStatistics(RPC2_Handle cid, RPC2_Integer *FilesAllocated, RPC2_Integer *FilesOccupied, RPC2_Integer *BlocksAllocated, RPC2_Integer *BlocksOccupied, RPC2_Integer *RVMAllocated, RPC2_Integer *RVMOccupied);
#define GetCacheStatistics_OP	5
extern ARG GetCacheStatistics_ARGS[];
#define GetCacheStatistics_PTR	GetCacheStatistics_ARGS

long C_GetNextHoardWalk(RPC2_Handle cid, RPC2_Integer *nextWalkTimeSeconds);
long S_GetNextHoardWalk(RPC2_Handle cid, RPC2_Integer *nextWalkTimeSeconds);
#define GetNextHoardWalk_OP	6
extern ARG GetNextHoardWalk_ARGS[];
#define GetNextHoardWalk_PTR	GetNextHoardWalk_ARGS

long C_OutputUsageStatistics(RPC2_Handle cid, RPC2_Integer UserID, RPC2_String Pathname, RPC2_Integer DisconnectionsSinceLastUse, RPC2_Integer PercentDisconnectionsUsed, RPC2_Integer TotalDisconnectionsUsed);
long S_OutputUsageStatistics(RPC2_Handle cid, RPC2_Integer UserID, RPC2_String Pathname, RPC2_Integer DisconnectionsSinceLastUse, RPC2_Integer PercentDisconnectionsUsed, RPC2_Integer TotalDisconnectionsUsed);
#define OutputUsageStatistics_OP	7
extern ARG OutputUsageStatistics_ARGS[];
#define OutputUsageStatistics_PTR	OutputUsageStatistics_ARGS

long C_HoardCommands(RPC2_Handle cid, RPC2_Integer UserID, RPC2_Integer commands_size_, HoardCmd commands[]);
long S_HoardCommands(RPC2_Handle cid, RPC2_Integer UserID, RPC2_Integer commands_size_, HoardCmd commands[]);
#define HoardCommands_OP	8
extern ARG HoardCommands_ARGS[];
#define HoardCommands_PTR	HoardCommands_ARGS

long C_ResultOfASR(RPC2_Handle cid, RPC2_Integer realm, VolumeId volume, RPC2_Integer ASRid, RPC2_Integer result);
long S_ResultOfASR(RPC2_Handle cid, RPC2_Integer realm, VolumeId volume, RPC2_Integer ASRid, RPC2_Integer result);
#define ResultOfASR_OP	9
extern ARG ResultOfASR_ARGS[];
#define ResultOfASR_PTR	ResultOfASR_ARGS

long C_ImminentDeath(RPC2_Handle cid, RPC2_String HostName, RPC2_Integer Port);
long S_ImminentDeath(RPC2_Handle cid, RPC2_String HostName, RPC2_Integer Port);
#define ImminentDeath_OP	10
extern ARG ImminentDeath_ARGS[];
#define ImminentDeath_PTR	ImminentDeath_ARGS

#ifdef __cplusplus
}
#endif
#define VenusAdvOPARRAYSIZE 11

extern CallCountEntry VenusAdv_CallCount[];

extern MultiCallEntry VenusAdv_MultiCall[];

extern MultiStubWork VenusAdv_MultiStubWork[];

extern long VenusAdv_ElapseSwitch;

extern long VenusAdv_EnqueueRequest;

#endif /* _VENUS_ADV_ */
